//package ie.moguntia.webcrawler;

//import ie.moguntia.threads.*;
import java.net.*;
import java.io.*;
import java.util.Vector;
import java.util.*;

public class WSDLCrawlerThread extends ControllableThread {
	static String base=null;
	static Set    outDomain = new HashSet();


	public void process(Object o) {
		// The objects that we're dealing with here a strings for urls
		try {
			URL pageURL = (URL) o;
            String mimetype = pageURL.openConnection().getContentType();
            // Discard all non-text files
            // Further assumptions on the mime type should not be made, because
            // some WSDLs advertise themselves as text/plain, others as text/xml
            // Anyway, we should try to identify WSDL pages by the definitions-
            // tag rather than by content-type.
            if (!mimetype.startsWith("text")) return;
			String rawPage = SaveURL.getURL(pageURL);
            // I don't know if it is legal, but we also want to identify the
            // file as WSDL if the definitions-tag is not spelled in small
            // letters.
            String smallPage = rawPage.toLowerCase().replaceAll("\\s", " ");
			if (smallPage.indexOf("<definitions") != -1) {
				// assume that it's a wsdl
				String filename = pageURL.getPath();
                // add a unique number as filename prefix
                int serviceId = tc.getUniqueNumber();
                filename = ((URLQueue) queue).getFilenamePrefix() + serviceId +
                    "-" + filename.substring(filename.lastIndexOf('/') + 1);
                // add suffix if not already there
                if (!filename.toLowerCase().endsWith(".wsdl"))
                    filename += ".wsdl";
				FileWriter fw = new FileWriter(filename);
				fw.write(rawPage);
				fw.close();
                // now try to retrieve the home page for the wsdl we have just
                // downloaded and store it as well
                URL homepage = new URL(pageURL.getProtocol(),
                    pageURL.getHost(),
                    "");    // leave filename blank
                filename = ((URLQueue) queue).getFilenamePrefix() + serviceId +
                    "-" + homepage.getHost() + ".html";
                SaveURL.writeURLtoFile(homepage, filename);
			} else {
				// treat the url a a html file and try to extract links
				Vector links = SaveURL.extractLinks(rawPage, smallPage);

				// Convert each link text to a url and enque
				for (int n = 0; n < links.size(); n++) {
					try {
						// urls might be relative to current page
						String sLink = (String) links.elementAt(n);

						int lI = sLink.lastIndexOf("/");
						String conc = "";
						if (lI > 0) {
							String s = sLink.substring(lI);
							if (s.indexOf(".") < 0)
								conc="/";								
						}
						sLink = sLink + conc;		


						URL link = new URL(pageURL, sLink);
						Set processed = queue.getProcessedElements();
						String a = pageURL.toString();
						a = a.trim().toUpperCase();
						String b = link.toString();
						b = b.trim().toUpperCase().toString();
						if (!outDomain.contains(link.toString()) && !a.equals(b)){
						//if (!processed.contains(link.toString()) && !outDomain.contains(link.toString()) && !a.equals(b)){
							String c =SaveURL.extractTitle(rawPage, smallPage);
							String d = pageURL.toString();
							String e = link.toString();
							c = c.replace('\\','/');
							d = d.replace('\\','/');
							e = e.replace('\\','/');
							if (c.charAt(c.length()-1)=='/')
								c = c.substring(0,c.length()-1);
							if (d.charAt(d.length()-1)=='/')
								d = d.substring(0,d.length()-1);
							if (e.charAt(e.length()-1)=='/')
								e = e.substring(0,e.length()-1);

							if (e.indexOf(d) >= 0) 
								HTCrawling.grava(c.trim()+","+d.trim()+ ","+e.trim());
						}

						if (base == null) base = pageURL.toString();

						if (link.toString().indexOf(base) >= 0 || link.toString().indexOf("http:") < 0)
							queue.push(link, level + 1);
						else
							outDomain.add(link.toString());
						HTCrawling.processou(".");
					} catch (MalformedURLException e) {
						// Ignore malformed URLs, the link extractor might
						// have failed.
					}
				}
			}
		} catch (Exception e) {
			// e.printStackTrace();
			// process of this object has failed, but we just ignore it here
		}
	}
}
