
/*
 *  HTGeodesic.java
 *  www.bouthier.net
 *
 *  The MIT License :
 *  -----------------
 *  Copyright (c) 2001 Christophe Bouthier
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a
 *  copy of this software and associated documentation files (the "Software"),
 *  to deal in the Software without restriction, including without limitation
 *  the rights to use, copy, modify, merge, publish, distribute, sublicense,
 *  and/or sell copies of the Software, and to permit persons to whom the
 *  Software is furnished to do so, subject to the following conditions:
 *  The above copyright notice and this permission notice shall be included in
 *  all copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 *  THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
 *  OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 *  ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 *  DEALINGS IN THE SOFTWARE.
 */
// Cdigo alterado por Silvio Evangelista

//package hypertree;

import java.awt.*;

import java.awt.event.*;

import java.net.URL;

//import javax.swing.*;

import java.applet.*;

import java.io.*;

import javax.swing.*;

import javax.swing.SwingUtilities;

import javax.swing.filechooser.*;
import java.util.*;

/**
 * The HTAction class manage the action on the hypertree :
 * drag of a node...
 *
 * @author     silvio
 * @created    29 de Setembro de 2004
 */

/*
 *  Antes:
 *  class HTAction
 *  extends MouseAdapter
 *  implements MouseMotionListener  {
 */
class HTAction
//extends MouseAdapter

		implements Serializable, MouseMotionListener, MouseListener, KeyListener,
		ActionListener {


	private HTDraw model = null;
	private String modelC = null;

	// the drawing model

	private HTNodeLabel label = null;

	private HTCoordE startPoint = null;

	// starting point of dragging

	private HTCoordE endPoint = null;

	// ending point of dragging

	private HTCoordS clickPoint = null;

	// clicked point

	private HTDrawNode node;

	private HTDrawNode nodeA;

	private HTDrawNode nodeH = null;

	private HTDrawNode nodeClicked;

	private HTDrawNode nodeClickedA;

	private HTDrawNode nodeClickedC;

	// Bruno

	private HTDialogShapes formas;

	/**
	 *  Description of the Field
	 */

	protected volatile int fClickCount;

	/**
	 *  Description of the Field
	 */

	protected volatile String nodeID = "";

	/**
	 *  Description of the Field
	 */

	protected volatile String nodeID_A = "";

	private Applet applet;

	private static boolean isDragged = false;

	private static Frame f = null;

	private JFileChooser fc;

	private boolean duploInsere = true;

	private boolean showLineGraph = true;


	/*
	 *  --- Constructor ---
	 */
	/**
	 * Constructor.
	 *
	 * @param  model    the drawing model
	 * @param  jApplet  Description of the Parameter
	 */

	HTAction(HTDraw model, Applet jApplet) {

		this.model = model;

		startPoint = new HTCoordE();

		endPoint = new HTCoordE();

		clickPoint = new HTCoordS();

		applet = jApplet;
	}


	/*
	 *  --- MouseAdapter ---
	 */
	/**
	 * Called when a user pressed the mouse button
	 * on the hyperbolic tree.
	 * Used to get the starting point of the drag.
	 *
	 * @param  e  the MouseEvent generated when clicking
	 */

	public void mousePressed(MouseEvent e) {

		if (e.isShiftDown()) {

			model.fastMode(true);

		}
		model.setHint(false);
		isDragged = true;
		startPoint.projectionStoE(e.getX(), e.getY(), model);
	}


	/**
	 * Called when a user release the mouse button
	 * on the hyperbolic tree.
	 * Used to signal the end of the translation.
	 *
	 * @param  e  not used here
	 */

	public void mouseReleased(MouseEvent e) {

		model.fastMode(false);

		model.endTranslation();

		isDragged = false;

	}


	/**
	 * Called when a user move mouse over a node on the hyperbolic tree.
	 * Used to put a hint on the corresponding node (if any) at the
	 * bellowf of the node.
	 *
	 * @param  e  the MouseEvent generated when clicking
	 */

	public void mouseEntered(MouseEvent e) {

	}


	/**
	 * Called when a user move mouse goes off a node on the hyperbolic tree.
	 * Used to drop a hint on the corresponding node (if any).
	 *
	 * @param  e  the MouseEvent generated when clicking
	 */

	public void mouseExited(MouseEvent e) {

	}


	//--- implement KeyListener

	/**
	 *  Description of the Method
	 *
	 * @param  ev  Description of the Parameter
	 */

	public void keyPressed(KeyEvent ev) {

		/*
		 *  int code = ev.getKeyCode();
		 *  switch (code) {
		 *  case KeyEvent.VK_UP:
		 *  System.out.println("Up key");
		 *  break;
		 *  case KeyEvent.VK_DOWN:
		 *  System.out.println("Down key");
		 *  break;
		 *  case KeyEvent.VK_LEFT:
		 *  System.out.println("Left key");
		 *  break;
		 *  case KeyEvent.VK_RIGHT:
		 *  System.out.println("Right key");
		 *  break;
		 *  case KeyEvent.VK_ALT:
		 *  System.out.println("1.) ALT com a tecla "+ ev.getKeyChar());
		 *  break;
		 *  case KeyEvent.VK_CONTROL:
		 *  System.out.println("CONTROL");
		 *  break;
		 *  default: System.out.println("Key press ignored");
		 *  }
		 *  if (ev.isAltDown())
		 *  System.out.println("Key Pressed "+ ev.getKeyChar());
		 */
	}


	/**
	 *  Description of the Method
	 *
	 * @param  ev  Description of the Parameter
	 */

	public void keyTyped(KeyEvent ev) {

		//System.out.println("key typed: " + ev.getKeyChar());

	}


	/**
	 *  Description of the Method
	 */

	public void edit() {

		//nodeClicked.setEspecialMark(true);

		String texto = nodeClicked.editFilho();

		if (model != null) {

			String nome = "";

			String nomeAresta = "";

			String cor = "";

			String hint_A = "";

			String URL_A = "";

			String cor_t = "";

			int inx;

			inx = texto.toLowerCase().indexOf("nome:");

			if (inx >= 0) {

				for (int i = inx + 5; i < texto.length(); i++) {

					if (texto.charAt(i) == ';') {

						break;
					} else {

						nome = nome + texto.charAt(i);

					}

				}

			}

			inx = texto.toLowerCase().indexOf("nomearesta:");

			if (inx >= 0) {

				for (int i = inx + 11; i < texto.length(); i++) {

					if (texto.charAt(i) == ';') {

						break;
					} else {

						nomeAresta = nomeAresta + texto.charAt(i);

					}

				}

			}

			inx = texto.toLowerCase().indexOf("cor:");

			if (inx >= 0) {

				for (int i = inx + 4; i < texto.length(); i++) {

					if (texto.charAt(i) == ';') {

						break;
					} else {

						cor = cor + texto.charAt(i);

					}

				}

			}

			inx = texto.toLowerCase().indexOf("hint:");

			if (inx >= 0) {

				for (int i = inx + 5; i < texto.length(); i++) {

					if (texto.charAt(i) == ';') {

						break;
					} else {

						hint_A = hint_A + texto.charAt(i);

					}

				}

			}

			inx = texto.toLowerCase().indexOf("url:");

			if (inx >= 0) {

				for (int i = inx + 4; i < texto.length(); i++) {

					if (texto.charAt(i) == ';') {

						break;
					} else {

						URL_A = URL_A + texto.charAt(i);

					}

				}

			}

			inx = texto.toLowerCase().indexOf("cor_texto:");

			if (inx >= 0) {

				for (int i = inx + 10; i < texto.length(); i++) {

					if (texto.charAt(i) == ';') {

						break;
					} else {

						cor_t = cor_t + texto.charAt(i);

					}

				}

			}

			model.setTextWord(nome);

			model.setArestaTextoField(nomeAresta);

			model.setCorWord(cor);

			model.setCorTextWord(cor_t);

			model.setHintWord(hint_A);

			model.setURLWord(URL_A);

		}
	}


	/**
	 *  Description of the Method
	 *
	 * @param  ev  Description of the Parameter
	 */

	public void keyReleased(KeyEvent ev) {

		if (ev.getKeyCode() == KeyEvent.VK_ESCAPE) {

			if (nodeH != null) {

				model.translateToOrigin(nodeH);

				nodeH = null;

				model.executaSearchWord("");

			}

			return;
		}

		if ((model != null) && (!model.getEditedChild())) {

			if ((ev != null) && (ev.isAltDown())) {

				if ((ev.getKeyChar() == 'e') && (nodeClicked != null)) {

					edit();

					nodeClickedA = nodeClicked;

					if (model != null) {

						model.reDraw(nodeClicked.getID());

					}
				}

				if ((ev.getKeyChar() == 's') && (nodeClicked != null)) {

					if (nodeClickedA != null) {

						//nodeClickedA.setEspecialMark(false);

						nodeClickedA.saveFilho("nome:" + model.getTexWord() + ";" + "nomeAresta:" + model.getNameArest() + ";" + "cor:" + model.getCorWord() + ";" + "cor_texto:" + model.getCorTextWord() + ";" + "hint:" + model.getHintWord() + ";" + "url:" + model.getURLWord());

						if (model != null) {
							model.reDraw(node.getID());
						}
					}
				}

				if ((ev.getKeyChar() == 'i') && (nodeClicked != null)) {

					//nodeClicked.setEspecialMark(false);

					if (nodeClicked.getID().indexOf("_H_") < 0) {
						nodeClicked.insereFilho();

						if (model != null) {

							if (node != null) {

								model.reDraw(node.getID());

							} else {

								model.reDraw();

							}

						}
					} else {
						HTDialogYesNo d = new HTDialogYesNo(f, "Insero", "Este tipo de n no pode possuir descententes ", "OK", null, null);
						d.show();
					}
				}

				if ((ev.getKeyChar() == 'd') && (nodeClicked != null)) {

					if (f == null) {

						f = new Frame("Ateno");

						f.setSize(100, 100);

						f.show();

					}

					f.setVisible(false);

					// Create an instance of InfoDialog, with title and message specified

					HTDialogYesNo d = new HTDialogYesNo(f, "Informao a respeito da remoo", "Voc tem certeza que deseja remover este n?", "Sim", "No", "Cancelar");

					// Register an action listener for the dialog.  This one just prints

					// the results out to the console.

					d.addActionListener(
						new ActionListener() {

							public void actionPerformed(ActionEvent e) {

								String answer = e.getActionCommand();
								if (answer.equals("yes")) {
									nodeClicked.deleteFilho();
									nodeClicked = null;
									if ((model != null)) {
										model.reDraw();
									}
								}
								f.setVisible(false);
							}
						});

					// Now pop the dialog up.  It will pop itself down automatically.

					d.show();

				}

				if ((ev.getKeyChar() == 'c') && (nodeClicked != null)) {

					//nodeClicked.setEspecialMark(true);

					nodeClickedC = nodeClicked;

					nodeClickedA = nodeClicked;

					model.setRamo(nodeClicked.getID());

					System.out.println("COPIANDO ...." + nodeClicked.getID());

					nodeClicked = null;

				}

				if ((ev.getKeyChar() == 'v') && (nodeClicked != null) && (nodeClicked != nodeClickedC)) {

					//nodeClicked.setEspecialMark(false);

					if (model != null) {

						if ((nodeClickedC != null) && (nodeClickedC.findRamo(nodeClicked.getID()) == null)) {

							//nodeClickedC.setEspecialMark(false);

							//nodeClicked.setEspecialMark(false);

							if (model.getRamo() != null) {

								nodeClicked.insereRamo(model.getRamo());

							}
						} else {

							System.out.println("Cpia no permitida");

						}

						nodeClickedC = null;

						nodeClickedA = null;

						//System.out.println("COLANDO EM ...." + nodeClicked.getID() + " O RAMO " + model.getRamo());

						model.setRamo(null);

						nodeClicked.setInseredChild(true);

						if (nodeClicked != null) {

							model.reDraw(nodeClicked.getID());

						} else {

							model.reDraw();

						}

					}

					nodeClicked = null;

				}

				// Inserindo Espelho **************************************************************************


				if ((ev.getKeyChar() == 'm') && (nodeClicked != null) && (nodeClicked != nodeClickedC)) {

					//nodeClicked.setEspecialMark(false);

					if (model != null) {

						if ((nodeClickedC != null) && (nodeClickedC.findRamo(nodeClicked.getID()) == null)) {

							//nodeClickedC.setEspecialMark(false);

							//nodeClicked.setEspecialMark(false);

							if (model.getRamo() != null) {

								nodeClicked.insereEspelho(model.getRamo());

							}
						} else {

							System.out.println("Cpia no permitida");

						}

						nodeClickedC = null;

						nodeClickedA = null;

						//System.out.println("COLANDO ESPELHO EM ...." + nodeClicked.getID() + " O RAMO " + model.getRamo());

						model.setRamo(null);

						nodeClicked.setInseredChild(true);

						if (nodeClicked != null) {

							model.reDraw(nodeClicked.getID());

						} else {

							model.reDraw();

						}

					}

					nodeClicked = null;

				}

				// Inserindo Link Escondido **************************************************************************


				if ((ev.getKeyChar() == 'h') && (nodeClicked != null) && (nodeClicked != nodeClickedC)) {

					//nodeClicked.setEspecialMark(false);

					if (model != null) {

						if ((nodeClickedC != null) && (nodeClickedC.findRamo(nodeClicked.getID()) == null)) {

							//nodeClickedC.setEspecialMark(false);

							//nodeClicked.setEspecialMark(false);

							if (model.getRamo() != null) {

								nodeClicked.insereHideLink(model.getRamo());

							}
						} else {

							System.out.println("Cpia no permitida");

						}

						nodeClickedC = null;

						nodeClickedA = null;

						System.out.println("COLANDO LINK ESCONDIDO EM ...." + nodeClicked.getID() + " O RAMO " + model.getRamo());

						model.setRamo(null);

						nodeClicked.setInseredChild(true);

						if (nodeClicked != null) {

							model.reDraw(nodeClicked.getID());

						} else {

							model.reDraw();

						}

					}

					nodeClicked = null;

				}
			}

			if ((ev != null) && (ev.isControlDown())) {

				if ((ev.getKeyChar() == 'c') && (nodeClicked != null)) {

					//nodeClicked.setEspecialMark(true);

					model.setRamo(nodeClicked.getID());

					System.out.println("COPIANDO ...." + nodeClicked.getID());

				}

				if ((ev.getKeyChar() == 'v') && (nodeClicked != null)) {

					//nodeClicked.setEspecialMark(true);

					nodeClicked.insereRamo(model.getRamo());

					System.out.println("COLANDO EM ...." + nodeClicked.getID() + " O RAMO " + model.getRamo());

					//model.setRamo(null);

					nodeClicked.setInseredChild(true);

					if (model != null) {

						model.reDraw();

					}
				}

				// Inserindo Espelho **************************************************************************

				if ((ev.getKeyChar() == 'm') && (nodeClicked != null)) {

					//nodeClicked.setEspecialMark(true);

					nodeClicked.insereEspelho(model.getRamo());

					nodeClicked.setInseredChild(true);

					System.out.println("COLANDO ESPELHO EM ...." + nodeClicked.getID() + " O RAMO " + model.getRamo());

					//model.setRamo(null);

					if (model != null) {

						model.reDraw();

					}
				}

				// Inserindo Link Escondido **************************************************************************

				if ((ev.getKeyChar() == 'h') && (nodeClicked != null)) {

					//nodeClicked.setEspecialMark(true);

					nodeClicked.insereHideLink(model.getRamo());

					nodeClicked.setInseredChild(true);

					//System.out.println("COLANDO LINK ESCONDIDO EM ...." + nodeClicked.getID() + " O RAMO " + model.getRamo());

					//model.setRamo(null);

					if (model != null) {

						model.reDraw();

					}
				}
			}
		}
	}


	/**
	 * Called when a user clicked on the hyperbolic tree.
	 * Used to put the corresponding node (if any) at the
	 * center of the hyperbolic tree.
	 *
	 * @param  e  the MouseEvent generated when clicking
	 */

	public void mouseClicked(MouseEvent e) {

		startPoint.projectionStoE(e.getX(), e.getY(), model);

		// Silvio

		if (e.isShiftDown()) {

			model.restore();

		} else {
			if (nodeClicked != null) {
				nodeClickedA = nodeClicked;
			}
			clickPoint.x = e.getX();
			clickPoint.y = e.getY();
			node = model.findNode(clickPoint);

			/*
			 *  Bruno
			 *  Verifica se o botao direito foi pressionado e abre a janela se nao for uma folha
			 */
			if (e.getButton() == 3 && node != null && !node.isLeafNode()) {
				Frame f = new Frame("Opcoes");
				HTDialogOpcoes opt = new HTDialogOpcoes(f, node);
				opt.show();
				model.folderFechadoGraphLine(node);
			} else {
				if (e.getButton() == 3) {
					if (nodeClicked != null) {
						nodeClicked.setEspecialMark(false);
					}
					if (nodeClickedA != null) {
						nodeClickedA.setEspecialMark(false);
					}
					if (nodeClickedC != null) {
						nodeClickedC.setEspecialMark(false);
					}
					model.reDraw();
					return;
				}
			}
			// Verifica se foi o botao esquerdo
			if (e.getButton() == 1) {
				model.setHint(false);
				// 13/09/2004
				int res1 = 0;
				//if (node != null) {
				//    res1 = node.verifyFolder(clickPoint);
				//}
				/*
				 *  if (res1 == 1) {
				 *  String hasFolder = node.getNodeClientData();
				 *  if (! node.isLeafNode()) {
				 *  / Bruno
				 *  /if (hasFolder.equals("11")) {
				 *  if (hasFolder.charAt(1) == '1') {
				 *  if (hasFolder.charAt(0) == '1') {
				 *  node.setNodeClientData("10");
				 *  }
				 *  if (hasFolder.charAt(0) == '0') {
				 *  node.setNodeClientData("00");
				 *  /node.setNodeClientData("10");
				 *  }
				 *  }
				 *  /if (hasFolder.equals("10")) {
				 *  if (hasFolder.charAt(1) == '0') {
				 *  if (hasFolder.charAt(0) == '1') {
				 *  node.setNodeClientData("11");
				 *  }
				 *  if (hasFolder.charAt(0) == '0') {
				 *  node.setNodeClientData("01");
				 *  /node.setNodeClientData("11");
				 *  }
				 *  }
				 *  }
				 *  }
				 *  / END
				 */
				if (node != null) {
					nodeClicked = node;
					if (nodeClickedA != null) {
						nodeClickedA.setEspecialMark(false);
					}
					if (nodeClickedC != null) {
						nodeClickedC.setEspecialMark(true);
					}
					node.setEspecialMark(true);
				} else {
					//nodeClicked = null;
				}

				if (node == null) {
					int res = model.verifyHomeClick(clickPoint);

					if (res == 1) {
						// Asking for Help
						String help = model.getHelpFile();

						if (help.length() > 2) {
							boolean UrlOnError = false;
							URL userUrl = null;
							try {
								userUrl = new URL(help);
							} catch (Exception urlError) {
								UrlOnError = true;
							}
							if (!UrlOnError) {
								applet.getAppletContext().showDocument(userUrl, "_blank");
							}
						}
					}

					if ((clickPoint != null) && (model.verifyOKClick(clickPoint))) {
						if (nodeClickedA != null) {
							if (model != null) {
								model.setEditedChild(false);
								model.reDraw();
								//nodeClickedA.setEspecialMark(false);
								if (nodeClickedA.getID().indexOf("_H_") < 0) {
									nodeClickedA.saveFilho("nome:" + model.getTexWord() + ";" + "nomeAresta:" + model.getNameArest() + ";" + "cor:" + model.getCorWord() + ";" + "cor_texto:" + model.getCorTextWord() + ";" + "hint:" + model.getHintWord() + ";" + "url:" + model.getURLWord());
								} else {
									nodeClickedA.saveFilho("nome:" + model.getTexWord() + ";" + "nomeAresta:" + model.getNameArest() + ";" + "cor:" + model.getCorWord() + ";" + "cor_texto:" + model.getCorTextWord() + ";" + "hint:" + nodeClickedA.getHint() + ";" + "url:" + model.getURLWord());
								}
								// Caso o n seja _H_, inserir nome da aresta no parte correspondente no vetor de linhas de grafo
								// 12/08/2008
								if (nodeClickedA.getID().indexOf("_H_") > 0) {
									model.setArestaLineGraph(nodeClickedA.getID(), model.getNameArest());
								}
								nodeClickedA.setEspecialMark(false);
								nodeClickedA = null;

							}
						}
					}

					if ((clickPoint != null) && (model.verifyCANCELClick(clickPoint))) {

						if (nodeClickedA != null) {
							if (model != null) {
								model.setEditedChild(false);
								model.reDraw();
								//nodeClickedA.setEspecialMark(false);
								nodeClickedA.setEspecialMark(false);
								nodeClickedA = null;
							}
						}
					}

					if ((clickPoint != null) && (model.verifyAplicarClick(clickPoint))) {
						if (nodeClickedA != null) {
							if (model != null) {
								model.setEditedChild(false);
								model.reDraw();
								//nodeClickedA.setEspecialMark(false);
								nodeClickedA.aplicarCoresFilhos("cor:" + model.getCorWord() + ";" + "cor_texto:" + model.getCorTextWord());
								nodeClickedA.setEspecialMark(false);
								nodeClickedA = null;

							}
						}
					}
				}

				if (node == null) {
					return;
				}

				if ((fClickCount = e.getClickCount()) == 1) {
					new Thread(
						new Runnable() {
							public void run() {
								try {
									Thread.sleep(600);
									if (fClickCount == 1) {
										fClickCount = 0;
										if (node != null) {
											// Silvio em 28/09/2004
											// Vou verificar se o n  do tipo link escondido
											int posH = node.getID().indexOf("_H_");
											if (posH >= 0) {
												HTDrawNode nodeC;
												String idNode = node.getID().substring(0, posH);
												if (!node.getFather().getID().equals(idNode)) {
													nodeC = model.findNode(idNode);
												} else {
													idNode = node.getID().substring(posH + 3);
													nodeC = model.findNode(idNode);
												}
												if (nodeC != null) {
													model.executaSearchWord(node.getID());
													model.translateToOrigin(nodeC);
													nodeH = node;
												}
											} else {
												posH = -1;
												if (nodeH != null) {
													posH = nodeH.getID().indexOf("_H_");
												}
												if (posH >= 0) {
													String idNode = nodeH.getID().substring(0, posH);
													if (node.getID().compareTo(idNode) == 0) {

														model.translateToOrigin(nodeH);

													} else {

														model.translateToOrigin(node);

													}
													nodeH = null;
													model.executaSearchWord("");
												} else {
													model.translateToOrigin(node);
												}
											}

											// **** SILVIO


											if (nodeClickedA != null) {
												if ((model != null) && (model.getEditedChild())) {
													//model.setEditedChild(false);
													model.reDraw();
													//nodeClickedA.setEspecialMark(false);
													if (nodeClickedA.getID().indexOf("_H_") < 0) {
														nodeClickedA.saveFilho("nome:" + model.getTexWord() + ";" + "nomeAresta:" + model.getNameArest() + ";" + "cor:" + model.getCorWord() + ";" + "cor_texto:" + model.getCorTextWord() + ";" + "hint:" + model.getHintWord() + ";" + "url:" + model.getURLWord());
													} else {
														nodeClickedA.saveFilho("nome:" + model.getTexWord() + ";" + "nomeAresta:" + model.getNameArest() + ";" + "cor:" + model.getCorWord() + ";" + "cor_texto:" + model.getCorTextWord() + ";" + "hint:" + nodeClickedA.getHint() + ";" + "url:" + model.getURLWord());
													}
													nodeClickedA.setEspecialMark(false);
													nodeClickedA = null;
													nodeClicked = node;
													edit();
													nodeClickedA = nodeClicked;
													if (model != null) {

														model.reDraw(nodeClicked.getID());

													}
												}
											}
										}
									} else {

										if (duploInsere) {

											if ((node != null) && (model != null) && (!model.getEditedChild())) {

												node = model.findNode(clickPoint);

												if (node.getID().indexOf("_H_") < 0) {
													String idNode = node.getID();
													//node.setEspecialMark(false);
													model.setCenter(idNode);
													node.insereFilho();
													model.reDraw(idNode);

												} else {
													HTDialogYesNo d = new HTDialogYesNo(f, "Insero", "Este tipo de n no pode possuir descententes ", "OK", null, null);
													d.show();
												}

											}
										} else {

											boolean UrlOnError = false;

											URL userUrl = null;

											String adr;

											boolean vazia = true;

											adr = node.getURL();

											boolean clickOnImage = model.getClickOnImage();

											if (!clickOnImage && ContaLinks(adr) > 1) {

												Frame f = new Frame();

												HTDialogLinks MessageLinks = new HTDialogLinks(f, node, model, applet);


												// Mostra a mensagem

												MessageLinks.show();

											}
											/*
											 *  Se existir apenas 1 link, ja abre o endereco no browser
											 */else {

												if ((adr != null) && (adr.trim().length() > 2)) {

													vazia = false;
													int pi = adr.indexOf("`");
													if (pi > 0) {
														adr = adr.substring(0, pi);
													}
												}

												String base = model.getUrlAdr();
												base = base.trim();

												//System.out.println("Imagem ? " + clickOnImage);


												if (clickOnImage) {

													try {

														userUrl = new URL(applet.getCodeBase(), "imagens/" + node.getNameImage());


														vazia = false;

													} catch (Exception urlError) {

														UrlOnError = true;

													}

												} else {


													if ((base.length() > 2) && adr.trim().toLowerCase().startsWith("http:")==false && adr.trim().toLowerCase().startsWith("file:")==false ) {

														if ((!vazia) && (adr.charAt(0) != '/')) {

															adr = base + "/" + adr;

														} else {

															adr = base + adr;

														}

													}

													if ((base.length() <= 2) && adr.toLowerCase().startsWith("http:")==false && adr.toLowerCase().startsWith("file:")==false) {

														try {

															userUrl = new URL(applet.getCodeBase(), adr);


														} catch (Exception urlError) {

															UrlOnError = true;

														}

													} else {

														try {

															userUrl = new URL(adr);

														} catch (Exception urlError) {

															UrlOnError = true;

														}

													}

												}

												if ((!UrlOnError) && (!vazia)) {
													applet.getAppletContext().showDocument(userUrl, "_blank");
												} else {
													System.out.println("URL Invlida " + adr);
													HTMessage s = new HTMessage("Erro: endereo URL incorretamente formatado.");
												}

											}

										}

										fClickCount = 0;

									}

								} catch (Exception ex) {

								} finally {

								}

							}

						}).start();

				}
			}
		}

		// Fim Bruno

	}


	/*
	 *  --- MouseMotionListener ---
	 */
	/**
	 * Called when a used drag the mouse on the hyperbolic tree.
	 * Used to translate the hypertree, thus moving the focus.
	 *
	 * @param  e  the MouseEvent generated when draging
	 */

	public void mouseDragged(MouseEvent e) {

		model.setHint(false);

		model.fastMode(true);

		isDragged = true;

		if (startPoint.isValid()) {

			endPoint.projectionStoE(e.getX(), e.getY(), model);

			if (endPoint.isValid()) {

				model.translate(startPoint, endPoint);

			}
		}
	}


	/**
	 * Called when the mouse mouve into the hyperbolic tree.
	 * Not used here.
	 *
	 * @param  e  the MouseEvent generated when mouving
	 */

	public void mouseMoved(MouseEvent e) {

		Point pt = e.getPoint();

		clickPoint.x = pt.x;
		clickPoint.y = pt.y;

		if ((fClickCount > 0) || (isDragged)) {
			return;
		}

		if (node == null) {
			nodeA = null;
		} else {
			if (nodeID.equals(nodeID_A) == false) {
				if (nodeA != null) {
					nodeA.setHasHint(false);
					model.setHint(false);
					model.reDraw();
				}
				nodeA = node;
				nodeID_A = nodeID;
			}
		}

		node = model.findNode(clickPoint);

		if (node != null) {
			String adr = node.getURL();

			if (!duploInsere) {
				if (ContaLinks(adr) > 0) {
					model.setViewFrameCursor(0);
				} else {
					model.setViewFrameCursor(2);
				}

			} else {
				model.setViewFrameCursor(1);

			}
		} else {

			model.setViewFrameCursor(2);
		}

		if (node != null) {
			if (nodeA != null) {
				//nodeA.setEspecialMark(false);
			}
			//node.setEspecialMark(true);
			if ((nodeID.equals(nodeID_A)) || (nodeID_A.equals(""))) {
				nodeID_A = nodeID;
			} else {
				nodeID_A = "";
			}
			nodeID = node.getID();
		} else {
			if (nodeA != null) {
				//nodeA.setEspecialMark(false);
				nodeA.setHasHint(false);
				//nodeA.setHintPai(false);
				model.setHint(false);
				model.reDraw();
			}

			nodeID_A = nodeID;

			nodeID = "";

		}

		if (node != null) {

			new Thread(
				new Runnable() {

					public void run() {

						try {

							if ((nodeID_A.equals("")) || (nodeID.equals(nodeID_A))) {

								Thread.sleep(600);

								if ((fClickCount > 0) || (isDragged)) {

									node.setHasHint(false);

									model.setHint(false);

									return;
								}

								if ((nodeID.equals("") == false) && (nodeID.equals(nodeID_A))) {

									node.setHasHint(true);

									model.setHint(true);

								}
							}

							model.reDraw();

						} catch (Exception ex) {

						} finally {

						}

					}

				}).start();

		}
	}


	/**
	 *  Description of the Method
	 *
	 * @param  evt  Description of the Parameter
	 */

	public void actionPerformed(ActionEvent evt) {

		if (model.getCheckBox() == evt.getSource()) {

			duploInsere = !duploInsere;
			/*
			 *  if (duploInsere) {
			 *  model.setViewFrameCursor(1);
			 *  } else {
			 *  model.setViewFrameCursor(2);
			 *  }
			 */
		}

		if (model.getCheckBox1() == evt.getSource()) {
			showLineGraph = !showLineGraph;
			if (showLineGraph) {
				model.setViewLineGraph(true);
			} else {
				model.setViewLineGraph(false);
			}
			model.reDraw();
		}

		if (model.getGravar() == evt.getSource()) {
			if (nodeClicked != null) {
				nodeClicked.setEspecialMark(false);
			}
			if (nodeClickedA != null) {
				nodeClickedA.setEspecialMark(false);
			}
			if (nodeClickedC != null) {
				nodeClickedC.setEspecialMark(false);
			}
			if (model != null) {
				model.grava();
			}
		}

		// Silvio 19/09/2006

		if (model.getVerificarLinks() == evt.getSource()) {
			if (model != null) {
				model.verificaLinks();
				model.reDraw();
			}
		}

		if (model.getFolderTree() == evt.getSource()) {
			if (model != null) {
				model.folderTree();
				model.reDraw();
			}
		}

		if (model.getWeb() == evt.getSource()) {
			if (model != null) {
				if (nodeClicked != null) {
					model.webCrawling(nodeClicked.getID());
					model.reDraw();
				}
			}
		}

		// Silvio

		if (model.getRecuperar() == evt.getSource()) {

			// Create an instance of InfoDialog, with title and message specified
			HTDialogYesNo d = new HTDialogYesNo(f, "Recuperao", "Voc tem certeza que deseja recuperar uma verso anterior?", "Sim", "No", "Cancelar");
			// Register an action listener for the dialog.  This one just prints
			// the results out to the console.
			d.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						String answer = e.getActionCommand();
						if (answer.equals("yes")) {
							if (model != null) {
								if (model.getHasUndo()) {
									model.undoRecupera();
									model.reDraw();
								}
							}
							if (nodeClicked != null) {
								nodeClicked.setEspecialMark(false);
							}
							if (nodeClickedA != null) {
								nodeClickedA.setEspecialMark(false);
							}

							nodeClicked = null;

						}
						f.setVisible(false);
					}
				});
			// Now pop the dialog up.  It will pop itself down automatically.
			d.show();
		}

		if (model.getColarEscondido() == evt.getSource()) {
			// Inserindo Link Escondido **************************************************************************
			if ((model != null) && (nodeClicked != null)) {
				//nodeClicked.setEspecialMark(true);
				if (nodeClicked != null && nodeClickedC != null && nodeClicked != nodeClickedC && (nodeClicked.getID().indexOf("_H_") < 0)) {
					/*
					 *  if (modelC != null) {
					 *  nodeClickedC.insereHideLink(modelC);
					 *  nodeClickedC.setInseredChild(true);
					 *  modelC = null;
					 *  }
					 */
					nodeClicked.insereHideLink(model.getRamo());
					nodeClicked.setInseredChild(true);

					model.addGraphLine(nodeClicked, nodeClickedC, false);
					//nodeClickedA);
					if (model != null) {
						model.reDraw();
					}
					nodeClicked.setEspecialMark(false);
					nodeClickedC.setEspecialMark(false);
					nodeClicked = null;
					nodeClickedC = null;
				}
			}
		}

		if (model.getColarED() == evt.getSource()) {
			// Inserindo Link Direcionado **************************************************************************
			if ((model != null) && (nodeClicked != null)) {
				//nodeClicked.setEspecialMark(true);
				if (nodeClicked != null && nodeClickedC != null && nodeClicked != nodeClickedC && (nodeClicked.getID().indexOf("_H_") < 0)) {
					nodeClicked.insereHideLinkD(model.getRamo());
					nodeClicked.setInseredChild(true);
					model.addGraphLine(nodeClicked, nodeClickedC, true);
					if (model != null) {
						model.reDraw();
					}
					nodeClicked.setEspecialMark(false);
					nodeClickedC.setEspecialMark(false);
					nodeClicked = null;
					nodeClickedC = null;
				}
			}
		}

		if (model.getInserir() == evt.getSource()) {
			/*
			if ((nodeClicked != null)) {
				if (nodeClicked.getID().indexOf("_H_") < 0) {
					nodeClicked.insereFilho();
					if (model != null) {
						model.reDraw(nodeClicked.getID());
					}
					nodeClicked.setEspecialMark(false);
				} else {
					HTDialogYesNo d = new HTDialogYesNo(f, "Insero", "Este tipo de n no pode possuir descententes ", "OK", null, null);
					d.show();
				}
			}
			*/
			
			if (nodeClicked != null) {
				if (model != null) {
					
					edit();

					nodeClickedA = nodeClicked;
					
					//System.out.println( "URL:" + model.getURLWord());
					if (model.getUrlAdr() == null || model.getUrlAdr().indexOf("editorLite") < 0) {
						HTDialogYesNo d = new HTDialogYesNo(f, "Editor Lite", "O caminho do Editor Lite no foi espeficicado. \nEspecifique o caminho na opo de configurao (campo: Endereo Base)", "OK", null, null);
						d.show();
					}
					else {
						//http://www.uol.com.br`(uol)`@!
						
						String  link = nodeClickedA.getID() + ".html";
						if (model.getURLWord().indexOf(link)<0) {
							link = link + "`(Metadado)`@!";
							nodeClickedA.saveFilho("nome:" + model.getTexWord() + ";" + "nomeAresta:" + model.getNameArest() + ";" + "cor:" + model.getCorWord() + ";" + "cor_texto:" + model.getCorTextWord() + ";" + "hint:" + model.getHintWord() + ";" + "url:" + model.getURLWord()+link);
						}	 
						// chamar o lite
						String base = model.getUrlAdr();	
						base = base.trim();

						//System.out.println("Imagem ? " + clickOnImage);							

						String adr = base + "?id=" +  nodeClickedA.getID();
						boolean UrlOnError = false;
						URL userUrl = null;
																		
						try {
							userUrl = new URL(adr);
						} catch (Exception urlError) {								
							UrlOnError = true;
						}
														
						if ((!UrlOnError)) {
							applet.getAppletContext().showDocument(userUrl, "_blank");
						} else {
							System.out.println("URL Invlida " + adr);
							HTMessage s = new HTMessage("Erro: endereo URL incorretamente formatado.");
						}
					}
					nodeClickedA.setEspecialMark(false);
					nodeClickedA = null;
				}
			}
		}

		if (model.getEditar() == evt.getSource()) {
			if ((nodeClicked != null)) {
				edit();
				nodeClickedA = nodeClicked;
				if (model != null) {
					model.reDraw(nodeClicked.getID());
				}
			}
		}

		if (model.getCopiar() == evt.getSource()) {
			if (nodeClickedC != null) {
				nodeClickedC.setEspecialMark(false);
			}
			if ((nodeClicked != null) && model != null && (nodeClicked.getID().indexOf("_H_") < 0)) {
				//nodeClicked.setEspecialMark(true);
				modelC = model.getRamo();
				nodeClickedC = nodeClicked;
				nodeClickedA = nodeClicked;
				model.setRamo(nodeClicked.getID());
				System.out.println("COPIANDO ...." + nodeClicked.getID());
				nodeClickedC.setEspecialMark(true);
				nodeClicked = null;

			}
		}

		if (model.getColar() == evt.getSource()) {
			if ((nodeClicked != null) && (nodeClickedC != null) && (nodeClicked != nodeClickedC)) {
				//nodeClicked.setEspecialMark(false);
				if (model != null) {
					if ((nodeClicked.getID().indexOf("_H_") < 0) && (nodeClickedC != null) && (nodeClickedC.findRamo(nodeClicked.getID()) == null)) {
						//nodeClickedC.setEspecialMark(false);
						//nodeClicked.setEspecialMark(false);
						if (model.getRamo() != null) {

							model.undoGrava();
							System.out.println("COLANDO EM ...." + nodeClicked.getID() + " O RAMO " + model.getRamo());
							nodeClicked.insereRamo(model.getRamo());
							//model.setRamo(null);

							nodeClicked.acertaGraphLine();
							//nodeClicked.getID());
						}
					} else {
						System.out.println("Cpia no permitida");
					}

					if (nodeClickedA != null) {
						nodeClickedA.setEspecialMark(false);
					}
					if (nodeClickedC != null) {
						nodeClickedC.setEspecialMark(false);
					}
					nodeClickedC = null;
					nodeClickedA = null;

					model.setRamo(null);
					if (nodeClicked != null) {
						model.reDraw(nodeClicked.getID());
					} else {
						model.reDraw();
					}
				}
				if (nodeClicked != null) {
					nodeClicked.setEspecialMark(false);
				}
				nodeClicked = null;
			}
		}

		if (model.getCentralizar() == evt.getSource()) {
			model.goOrigem();
		}

		if (model.getMesclar() == evt.getSource()) {
			if (nodeClicked != null) {
				int state = FileDialog.LOAD;
				String msg = "Defina a rvore a ser carregada.";
				FileDialog file = new FileDialog(model.getViewFrame(), msg, state);
				file.setFile("*.htz");
				file.show();
				String curFile;
				String filename = null;
				if ((curFile = file.getFile()) != null) {
					filename = file.getDirectory() + curFile;
				}
				nodeClicked.setInseredChild(true);
				model.loadTreeAt(nodeClicked, curFile);
				model.reDraw(nodeClicked.getID());
				nodeClicked.setEspecialMark(false);
			} else {
				HTDialogYesNo d = new HTDialogYesNo(f, "Mesclar", "Voc precisa selecionar um n", "OK", null, null);
				d.show();
			}
		}

		if (model.getDeletar() == evt.getSource()) {
			if ((nodeClicked != null)) {
				if (f == null) {
					f = new Frame("Ateno");
					f.setSize(100, 100);
					f.show();
				}
				f.setVisible(false);

				// Create an instance of InfoDialog, with title and message specified
				HTDialogYesNo d = new HTDialogYesNo(f, "Informao a respeito da remoo", "Voc tem certeza que deseja remover o n " + nodeClicked.getName() + "(" + nodeClicked.getID() + ")?", "Sim", "No", "Cancelar");
				// Register an action listener for the dialog.  This one just prints
				// the results out to the console.
				d.addActionListener(
					new ActionListener() {
						public void actionPerformed(ActionEvent e) {
							String answer = e.getActionCommand();
							if (answer.equals("yes")) {
								model.undoGrava();
								HTDrawNode del = null;
								if (nodeClicked.getID().indexOf("_H_") > 0) {
									del = nodeClicked.getFather();
								} else {
									del = nodeClicked;
								}
								model.removeGraphLine(del);
								nodeClicked.deleteFilho();
								nodeClicked = null;
								if ((model != null)) {
									model.reDraw();
								}
							}
							f.setVisible(false);
						}
					});
				// Now pop the dialog up.  It will pop itself down automatically.
				d.show();
			}
		}

		if (model.getAplicarT() == evt.getSource()) {
			if (nodeClickedA != null) {
				if (model != null) {
					model.undoGrava();
					//model.setEditedChild(false);
					//nodeClickedA.setEspecialMark(false);
					nodeClickedA.aplicarCoresFilhos("cor_texto:" + model.getCorTextWord());
					//nodeClickedA = null;
					model.reDraw();
				}
			}
		}

		if (model.getAplicarF() == evt.getSource()) {
			if (nodeClickedA != null) {
				if (model != null) {
					model.undoGrava();
					//model.setEditedChild(false);
					//nodeClickedA.setEspecialMark(false);
					nodeClickedA.aplicarCoresFilhos("cor:" + model.getCorWord());
					//nodeClickedA = null;
					model.reDraw();

				}
			}
		}

		// New Color Picker 19/04/2005


		if (model.getCorT() == evt.getSource()) {

			HTColorPicker colorPicker = new HTColorPicker();

			Color c = colorPicker.getColorRGB();

			TextField result = model.getCorTextF();

			TextField result1 = model.getCorFieldF();

			if (c != null) {

				result.setText(colorPicker.getColorRGBHEX());

				result1.setForeground(c);

				result.setForeground(c);

			}
		}

		// Imagem 16/06/2008


		if (model.getAplicarI() == evt.getSource()) {

			if (nodeClickedA.getID().indexOf("_H_") > 0) {
				HTDialogYesNo d = new HTDialogYesNo(f, "Imagem", "No se pode associar uma imagem a este tipo de n" + nodeClicked.getName(), "OK", null, null);
				d.show();
				return;
			}

			//Set up the file chooser.

			/*
			 *  if (fc == null) {
			 *  String curDir = model.getPath();
			 *  try {
			 *  fc = new JFileChooser(curDir);
			 *  fc.addChoosableFileFilter(new ImageFilter());
			 *  /fc.setAcceptAllFileFilterUsed(false);
			 *  fc.setFileView(new ImageFileView());
			 *  fc.setAccessory(new ImagePreview(fc));
			 *  } catch (Exception e) {
			 *  }
			 *  }
			 */
			int state = FileDialog.LOAD;

			String msg = "Associe uma imagem";

			FileDialog file = new FileDialog(model.getViewFrame(),
					msg, state);

			file.setFile("*.jpg;*.png;*.gif");

			// set initial filename filter

			file.show();

			// Blocks

			String curFile;

			String filename = null;

			if ((curFile = file.getFile()) != null) {

				filename = file.getDirectory() + curFile;

			}

			System.out.println(filename + " " + curFile);

			//Show it.

			/*
			 *  int returnVal = fc.showDialog(model.getViewFrame(), "Associe");
			 *  if (returnVal == JFileChooser.APPROVE_OPTION) {
			 *  File file = fc.getSelectedFile();
			 */
			//log.append("Attaching file: " + file.getName() + "." + newline);

			// Associar Imagem e Copi-la para o diretrio Imagens, caso ela no esteja l

			if (filename != null) {

				//nodeClickedA.setNameImage(file.getName(), file.getPath()); // JFileChosser

				nodeClickedA.setNameImage(curFile, filename);

				//file.getDirectory() );

				try {

					String cam1 = filename;

					//file.getCanonicalPath();

					//String cam2 = model.getPath().substring(0, model.getPath().length() - 1).replace("/", "\\") + "\\imagens\\" + file.getName();

					String cam2 = model.getPath().substring(0, model.getPath().length() - 1).replace("/", "\\") + "\\imagens\\" + curFile;


					if (!cam1.trim().toUpperCase().equals(cam2.trim().toUpperCase())) {

						//SalvaArquivo(file.getName(), file);

						SalvaArquivo(curFile, filename);

					}
				} catch (Exception e) {

				}

				//if(!fc.getCurrentDirectory().toString().equals(view.getPath().substring(1,view.getPath().length()-1 ).replace("/", "'\'")))

			}
			//}

			//Reset the file chooser for the next time it's shown.

			//fc.setSelectedFile(null); // JFileChosser

		}

		if (model.getAplicarRI() == evt.getSource()) {

			nodeClickedA.setRemoveImage();

		}

		if (model.getCorF() == evt.getSource()) {

			HTColorPicker colorPicker = new HTColorPicker();

			Color c = colorPicker.getColorRGB();

			TextField result = model.getCorFieldF();

			if (c != null) {

				result.setText(colorPicker.getColorRGBHEX());

				result.setBackground(c);

			}
		}

		// 19/04/2005


		if (model.getOk() == evt.getSource()) {

			if (nodeClickedA != null) {

				if (model != null) {

					model.setEditedChild(false);

					model.reDraw();

					//nodeClickedA.setEspecialMark(false);
					if (nodeClickedA.getID().indexOf("_H_") < 0) {
						nodeClickedA.saveFilho("nome:" + model.getTexWord() + ";" + "nomeAresta:" + model.getNameArest() + ";" + "cor:" + model.getCorWord() + ";" + "cor_texto:" + model.getCorTextWord() + ";" + "hint:" + model.getHintWord() + ";" + "url:" + model.getURLWord());
					} else {
						nodeClickedA.saveFilho("nome:" + model.getTexWord() + ";" + "nomeAresta:" + model.getNameArest() + ";" + "cor:" + model.getCorWord() + ";" + "cor_texto:" + model.getCorTextWord() + ";" + "hint:" + nodeClickedA.getHint() + ";" + "url:" + model.getURLWord());
					}

					// Caso o n seja _H_, inserir nome da aresta no parte correspondente no vetor de linhas de grafo
					// 12/08/2008
					if (nodeClickedA.getID().indexOf("_H_") > 0) {
						model.setArestaLineGraph(nodeClickedA.getID(), model.getNameArest());
					}
//System.out.println(nodeClickedA.getURL());
					nodeClickedA = null;



				}
			}
		}

		if (model.getCancel() == evt.getSource()) {

			if (nodeClickedA != null) {

				if (model != null) {

					model.setEditedChild(false);

					model.reDraw();

					//nodeClickedA.setEspecialMark(false);

					nodeClickedA = null;

				}
			}
		}

		// Envento para mostrar a caixa de links

		if (model.getLinks() == evt.getSource()) {

			if (nodeClickedA != null) {

				if (model != null) {

					Frame f = new Frame("Ateno");

					HTDialogURLs urls = new HTDialogURLs(f, model.view);

					urls.show();

				}
			}
		}

		// Envento para mostrar a caixa de formas (shapes)

		if (model.getFormas() == evt.getSource()) {

			if (nodeClickedA.getID().indexOf("_H_") > 0) {
				HTDialogYesNo d = new HTDialogYesNo(f, "Formas", "No se pode associar um polgono a este tipo de n" + nodeClicked.getName(), "OK", null, null);
				d.show();
				return;
			}

			if (nodeClickedA != null && nodeClicked != null) {

				// if (model != null ) {

				model.mostraDlgFormas(nodeClicked);

				// }

			}
		}

		// Envento para mostrar a caixa para configurar o navegador

		if (model.getConfigNavegador() == evt.getSource()) {

			if (model != null) {

				model.configNavegador();

				model.reDraw();

			}
		}
	}


	/**
	 *  Description of the Method
	 *
	 * @param  nomeImgEscolhida       Description of the Parameter
	 * @param  nomeEscolhidoCompleto  Description of the Parameter
	 */

	void SalvaArquivo(String nomeImgEscolhida,
			String nomeEscolhidoCompleto) {

		System.out.println("Salvando arquivo");

		try {

			File imgSalva = new File(model.getPath() + "//imagens//" + nomeImgEscolhida);

			File fileEscolhido = new File(nomeEscolhidoCompleto);

			//if(!imgSalva.exists()) {

			InputStream in = new FileInputStream(fileEscolhido);

			OutputStream out = new FileOutputStream(imgSalva);

			byte[] buf = new byte[1024];

			int len;

			while ((len = in.read(buf)) > 0) {

				out.write(buf, 0, len);

			}

			in.close();

			out.close();

			//}

		} catch (Exception e) {

			System.out.println("Salvando arquivo ERROI");

		}

	}


	/*
	 *  Conta quantos links tem na string
	 */
	/**
	 *  Description of the Method
	 *
	 * @param  URLs  Description of the Parameter
	 * @return       Description of the Return Value
	 */

	int ContaLinks(String URLs) {


		int NumLinks = 0;

		if (URLs == null || URLs.trim().length() < 1) {

			return 0;
		}

		for (int i = 0; i < URLs.length(); i++) {

			if (URLs.charAt(i) == '@') {

				NumLinks++;

			}
		}

		if (NumLinks == 0) {

			NumLinks++;

		}

		return NumLinks;
	}

}


