/*
 *  HTDialogNavegador.java
 *
 *  Created on 4 de Setembro de 2008, 09:32
 */

import java.awt.*;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JColorChooser;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import java.awt.Toolkit;
import java.applet.*;
import java.net.URL;

/**
 * @author     Bruno
 * @created    8 de Setembro de 2008
 */
public class HTDialogNavegador extends javax.swing.JDialog {

    HTView view;
    String imgFundo;
    HTApplet applet;
    File imgEscolhida;
    String nomeImg;
    String fileName;

    /**
     * Creates new form HTDialogNavegador
     *
     * @param  parent  Description of the Parameter
     * @param  modal   Description of the Parameter
     * @param  rview   Description of the Parameter
     * @param  htFile  Description of the Parameter
     * @param  ap      Description of the Parameter
     */
    public HTDialogNavegador(java.awt.Frame parent, boolean modal, HTView rview, String htFile, HTApplet ap) {
        super(parent, modal);
        view = rview;
        applet = ap;
	  //setModal(true);
	  //setVisible(true);
	  initComponents();
        inicializaCampos(htFile);
    }


    /**
     *  Description of the Method
     *
     * @param  htFile  Description of the Parameter
     */
    void inicializaCampos(String htFile) {
        txtCorHint.setText(view.getHintColor());
        btnCorHint.setBackground(Color.decode(view.getHintColor()));
        txtCorFundo.setText(view.getBackColor());
        btnCorFundo.setBackground(Color.decode(view.getBackColor()));
        txtCorBusca.setText(view.getSearchColor());
        btnCorBusca.setBackground(Color.decode(view.getSearchColor()));
        txtCorLink.setText(view.getLinkColor());
        btnCorLink.setBackground(Color.decode(view.getLinkColor()));
	  txtCorGrafo.setText(view.getGraphColor());
        btnCorGrafo.setBackground(Color.decode(view.getGraphColor()));

        txtURL.setText(view.getUrlAdr());
        lblArqHtz.setText(htFile);
	
	String arquivo = view.getNameFileShape();
	int ip = arquivo.lastIndexOf("\\");
	if (ip>0)
		arquivo = arquivo.substring(ip+1);
	else {
		ip = arquivo.lastIndexOf("/");
		if (ip>0)
			arquivo = arquivo.substring(ip+1);
	}
        lblArqPoligonos.setText(arquivo);
        txtImgFundo.setText(applet.gethtBackImage());
	if (view.getOpenWindow().trim().toLowerCase().equals("new"))
		chkLinks.setSelected(true);
	else
		chkLinks.setSelected(false);

        // Inicializa o combobox dao tamanho da fonte de acordo com o view
        for (int k = 0; k < cmbFonts.getItemCount(); k++) {
            if (cmbFonts.getItemAt(k).toString().toLowerCase().equals(view.getFontNode().toLowerCase())) {
                cmbFonts.setSelectedIndex(k);
            }
        }
        // Inicializa o combobox dao tamanho da fonte de acordo com o view
        for (int k = 0; k < cmbFontSize.getItemCount(); k++) {
            if (Integer.parseInt(cmbFontSize.getItemAt(k).toString()) == view.getFontSizeNode()) {
                cmbFontSize.setSelectedIndex(k);
            }
        }
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    //  @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        txtCorHint = new javax.swing.JTextField();
        txtCorFundo = new javax.swing.JTextField();
        txtCorBusca = new javax.swing.JTextField();
        txtCorLink = new javax.swing.JTextField();
        btnCorHint = new javax.swing.JButton();
        btnCorFundo = new javax.swing.JButton();
        btnCorLink = new javax.swing.JButton();
        btnCorBusca = new javax.swing.JButton();
        jLabel6 = new javax.swing.JLabel();
        txtCorGrafo = new javax.swing.JTextField();
        btnCorGrafo = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        txtImgFundo = new javax.swing.JTextField();
        btnImgFundo = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        cmbFonts = new javax.swing.JComboBox();
        jLabel9 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        cmbFontSize = new javax.swing.JComboBox();
        jPanel4 = new javax.swing.JPanel();
        jLabel8 = new javax.swing.JLabel();
        lblArqHtz = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        lblArqPoligonos = new javax.swing.JLabel();
        jPanel5 = new javax.swing.JPanel();
        jLabel13 = new javax.swing.JLabel();
        txtURL = new javax.swing.JTextField();
        jPanel6 = new javax.swing.JPanel();
        chkLinks = new javax.swing.JCheckBox();
        btnSalvar = new javax.swing.JButton();
        btnFechar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Configurar Navegador");
        setResizable(false);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Cores"));

        jLabel1.setText("Hint :");

        jLabel2.setText("Fundo :");

        jLabel3.setText("Link :");

        jLabel4.setText("Busca :");

        btnCorHint.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCorHintActionPerformed(evt);
            }
        });

        btnCorFundo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCorFundoActionPerformed(evt);
            }
        });

        btnCorLink.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCorLinkActionPerformed(evt);
            }
        });

        btnCorBusca.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCorBuscaActionPerformed(evt);
            }
        });
		
		btnCorGrafo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCorGrafoActionPerformed(evt);
            }
        });

        jLabel6.setText("Grafo :");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jLabel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addComponent(jLabel6))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(txtCorGrafo, javax.swing.GroupLayout.DEFAULT_SIZE, 119, Short.MAX_VALUE)
                    .addComponent(txtCorHint, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 119, Short.MAX_VALUE)
                    .addComponent(txtCorFundo, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 119, Short.MAX_VALUE)
                    .addComponent(txtCorLink, javax.swing.GroupLayout.DEFAULT_SIZE, 119, Short.MAX_VALUE)
                    .addComponent(txtCorBusca, javax.swing.GroupLayout.DEFAULT_SIZE, 119, Short.MAX_VALUE))
                .addGap(9, 9, 9)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(btnCorGrafo, 0, 0, Short.MAX_VALUE)
                    .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addComponent(btnCorBusca, javax.swing.GroupLayout.Alignment.LEADING, 0, 0, Short.MAX_VALUE)
                        .addComponent(btnCorLink, javax.swing.GroupLayout.Alignment.LEADING, 0, 0, Short.MAX_VALUE)
                        .addComponent(btnCorFundo, javax.swing.GroupLayout.Alignment.LEADING, 0, 0, Short.MAX_VALUE)
                        .addComponent(btnCorHint, javax.swing.GroupLayout.PREFERRED_SIZE, 27, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel1)
                            .addComponent(txtCorHint, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel2)
                            .addComponent(txtCorFundo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(txtCorLink, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel3))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel4)
                            .addComponent(txtCorBusca, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(btnCorHint, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnCorFundo, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnCorLink, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnCorBusca, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel6)
                        .addComponent(txtCorGrafo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(btnCorGrafo, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createTitledBorder("Imagens")));

        jLabel5.setText("Fundo :");

        btnImgFundo.setText("...");
        btnImgFundo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnImgFundoActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addComponent(jLabel5)
                .addGap(8, 8, 8)
                .addComponent(txtImgFundo, javax.swing.GroupLayout.DEFAULT_SIZE, 274, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnImgFundo)
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(txtImgFundo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btnImgFundo, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(14, Short.MAX_VALUE))
        );

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder("Fonte"));

        cmbFonts.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Arial", "Arial Black", "Arial Rounded MT Bold", "Arial Unicode MS", "Comic Sans MS", "Cooper Black", "Courier New", "Tahoma", "Times New Roman" }));

        jLabel9.setText("Nome :");

        jLabel11.setText("Tamanho :");

        cmbFontSize.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "8", "10", "12", "14", "16", "18", "20" }));

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel9)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(cmbFonts, javax.swing.GroupLayout.PREFERRED_SIZE, 120, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 13, Short.MAX_VALUE)
                .addComponent(jLabel11)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(cmbFontSize, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel9)
                    .addComponent(cmbFonts, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(cmbFontSize, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel11))
                .addGap(9, 9, 9))
        );

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder("Arquivos"));

        jLabel8.setText("HTZ :");

        lblArqHtz.setText("htz");

        jLabel10.setText("Polgonos :");

        lblArqPoligonos.setText("poli");

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createSequentialGroup()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel4Layout.createSequentialGroup()
                        .addComponent(jLabel10)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(lblArqPoligonos, javax.swing.GroupLayout.DEFAULT_SIZE, 320, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel4Layout.createSequentialGroup()
                        .addComponent(jLabel8)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(lblArqHtz, javax.swing.GroupLayout.DEFAULT_SIZE, 346, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel8)
                    .addComponent(lblArqHtz))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel10)
                    .addComponent(lblArqPoligonos, javax.swing.GroupLayout.DEFAULT_SIZE, 23, Short.MAX_VALUE)))
        );

        jPanel5.setBorder(javax.swing.BorderFactory.createTitledBorder("URL"));

        jLabel13.setText("Endereo base :");

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel13)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(txtURL, javax.swing.GroupLayout.DEFAULT_SIZE, 524,  Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel13)
                    .addComponent(txtURL, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        jPanel6.setBorder(javax.swing.BorderFactory.createTitledBorder("Opo para links"));

        chkLinks.setText("Abrir links em uma nova janela");

        javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addComponent(chkLinks)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(chkLinks)
        );

        btnSalvar.setText("Salvar");
        btnSalvar.setMaximumSize(new java.awt.Dimension(65, 23));
        btnSalvar.setMinimumSize(new java.awt.Dimension(65, 23));
        btnSalvar.setPreferredSize(new java.awt.Dimension(65, 23));
        btnSalvar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSalvarActionPerformed(evt);
            }
        });

        btnFechar.setText("Fechar");
        btnFechar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnFecharActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel5, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(btnSalvar, javax.swing.GroupLayout.DEFAULT_SIZE, 126, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(btnFechar, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 126, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(btnFechar, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnSalvar, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jPanel6, javax.swing.GroupLayout.DEFAULT_SIZE, 59, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, 59, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>

    // </editor-fold>
    /**
     *  Description of the Method
     *
     * @param  evt  Description of the Parameter
     */
    private void btnSalvarActionPerformed(java.awt.event.ActionEvent evt) {
        SalvarArquivoEditor();
        SalvarArquivoNav();
        if (imgEscolhida != null) {
            try {
                String cam1 = imgEscolhida.getCanonicalPath();
                String cam2 = view.getPath().substring(0, view.getPath().length() - 1).replace("/", "\\") + "\\" + imgEscolhida.getName();

                if (!cam1.trim().toUpperCase().equals(cam2.trim().toUpperCase())) {
                    SalvaArquivo();
                    System.out.println("getCanonicalPath " + cam1);
                    System.out.println("view.getPath() " + cam2);
                }
            } catch (Exception e) {
            }
        //if(!fc.getCurrentDirectory().toString().equals(view.getPath().substring(1,view.getPath().length()-1 ).replace("/", "'\'")))

        }
        AtualizaView();
    }

    /**
     *  Description of the Method
     */
    private void AtualizaView() {
        //view.setHintColor(txtCorHint.getText());
        //view.setBackColor(txtCorFundo.getText());
        //view.setLinkColor(txtCorLink.getText());
        //view.setSearchColor(txtCorBusca.getText());
        view.setFontNode(cmbFonts.getSelectedItem().toString());
        view.setFontSizeNode(Integer.parseInt(cmbFontSize.getSelectedItem().toString()));
        view.setUrlAdr(txtURL.getText());
        view.setBackImage(applet.getImage(applet.getCodeBase(), txtImgFundo.getText()));
        //imgFundo = txtImgFundo.getText();

        applet.sethtFontNode(cmbFonts.getSelectedItem().toString());
        applet.sethtFontSizeNode(cmbFontSize.getSelectedItem().toString());
        applet.sethtBackImage(txtImgFundo.getText());
        applet.sethtBackColor(txtCorFundo.getText());
        applet.sethtLinkColor(txtCorLink.getText());
        applet.sethtSearchColor(txtCorBusca.getText());
        applet.sethtHintColor(txtCorHint.getText());
		applet.sethtGraphColor(txtCorGrafo.getText());

        //applet.setBackColorAp();
        // Atualiza o applet sem fechar a janela
        view.reDraw();
    }

    /**
     *  Description of the Method
     *
     * @param  evt  Description of the Parameter
     */
    private void btnFecharActionPerformed(java.awt.event.ActionEvent evt) {
        this.dispose();
    }

    /**
     *  Description of the Method
     *
     * @param  evt  Description of the Parameter
     */
    private void btnCorHintActionPerformed(java.awt.event.ActionEvent evt) {
        final JColorChooser clr = new JColorChooser();
        if (!txtCorHint.getText().isEmpty()) {
            clr.setColor(Color.decode(txtCorHint.getText()));
        }
        ActionListener okActionListener =
                new ActionListener() {

                    public void actionPerformed(ActionEvent actionEvent) {
                        int cor = clr.getColor().getRGB() & 0x00ffffff;
                        // Converte o valor do RGB pra Hexadecimal
                        txtCorHint.setText("" + cor);
                        btnCorHint.setBackground(clr.getColor());
                    }
                };

        ActionListener cancelActionListener =
                new ActionListener() {

                    public void actionPerformed(ActionEvent actionEvent) {
                    }
                };

        final JDialog dialog = JColorChooser.createDialog(null, "Escolha a cor do HINT", true,
                clr, okActionListener, cancelActionListener);

        dialog.setVisible(true);
    }

    /**
     *  Description of the Method
     *
     * @param  evt  Description of the Parameter
     */
    private void btnCorFundoActionPerformed(java.awt.event.ActionEvent evt) {
        final JColorChooser clr = new JColorChooser();
        if (!txtCorFundo.getText().isEmpty()) {
            clr.setColor(Color.decode(txtCorFundo.getText()));
        }
        ActionListener okActionListener =
                new ActionListener() {

                    public void actionPerformed(ActionEvent actionEvent) {
                        int cor = clr.getColor().getRGB() & 0x00ffffff;
                        // Converte o valor do RGB pra Hexadecimal
                        txtCorFundo.setText("" + cor);
                        btnCorFundo.setBackground(clr.getColor());

                    }
                };

        ActionListener cancelActionListener =
                new ActionListener() {

                    public void actionPerformed(ActionEvent actionEvent) {
                    }
                };

        final JDialog dialog = JColorChooser.createDialog(null, "Escolha a cor do FUNDO", true,
                clr, okActionListener, cancelActionListener);

        dialog.setVisible(true);
    }

    /**
     *  Description of the Method
     *
     * @param  evt  Description of the Parameter
     */
    private void btnCorLinkActionPerformed(java.awt.event.ActionEvent evt) {
        final JColorChooser clr = new JColorChooser();
        if (!txtCorLink.getText().isEmpty()) {
            clr.setColor(Color.decode(txtCorLink.getText()));
        }
        ActionListener okActionListener =
                new ActionListener() {

                    public void actionPerformed(ActionEvent actionEvent) {
                        int cor = clr.getColor().getRGB() & 0x00ffffff;
                        // Converte o valor do RGB pra Hexadecimal
                        txtCorLink.setText("" + cor);
                        btnCorLink.setBackground(clr.getColor());
                    }
                };

        ActionListener cancelActionListener =
                new ActionListener() {

                    public void actionPerformed(ActionEvent actionEvent) {
                    }
                };

        final JDialog dialog = JColorChooser.createDialog(null, "Escolha a cor do LINK", true,
                clr, okActionListener, cancelActionListener);

        dialog.setVisible(true);
    }

    /**
     *  Description of the Method
     *
     * @param  evt  Description of the Parameter
     */
    private void btnCorBuscaActionPerformed(java.awt.event.ActionEvent evt) {
        final JColorChooser clr = new JColorChooser();
        if (!txtCorBusca.getText().isEmpty()) {
            clr.setColor(Color.decode(txtCorBusca.getText()));
        }
        ActionListener okActionListener =
                new ActionListener() {

                    public void actionPerformed(ActionEvent actionEvent) {
                        int cor = clr.getColor().getRGB() & 0x00ffffff;
                        // Converte o valor do RGB pra Hexadecimal
                        txtCorBusca.setText("" + cor);
                        btnCorBusca.setBackground(clr.getColor());
                    }
                };

        ActionListener cancelActionListener =
                new ActionListener() {

                    public void actionPerformed(ActionEvent actionEvent) {
                    }
                };

        final JDialog dialog = JColorChooser.createDialog(null, "Escolha a cor do BUSCA", true,
                clr, okActionListener, cancelActionListener);

        dialog.setVisible(true);
    }
	
	    /**
     *  Description of the Method
     *
     * @param  evt  Description of the Parameter
     */
    private void btnCorGrafoActionPerformed(java.awt.event.ActionEvent evt) {
        final JColorChooser clr = new JColorChooser();
        if (!txtCorGrafo.getText().isEmpty()) {
            clr.setColor(Color.decode(txtCorGrafo.getText()));
        }
        ActionListener okActionListener =
                new ActionListener() {
                    public void actionPerformed(ActionEvent actionEvent) {
                        int cor = clr.getColor().getRGB() & 0x00ffffff;
                        // Converte o valor do RGB pra Hexadecimal
                        txtCorGrafo.setText("" + cor);
                        btnCorGrafo.setBackground(clr.getColor());
                    }
                };

        ActionListener cancelActionListener =
                new ActionListener() {

                    public void actionPerformed(ActionEvent actionEvent) {
                    }
                };

        final JDialog dialog = JColorChooser.createDialog(null, "Escolha a cor da linha do GRAFO", true,
                clr, okActionListener, cancelActionListener);

        dialog.setVisible(true);
    }

    /**
     *  Description of the Method
     *
     * @param  evt  Description of the Parameter
     */
    private void btnImgFundoActionPerformed(java.awt.event.ActionEvent evt) {
        int state = FileDialog.LOAD;
        String msg = "Associe uma imagem de Fundo";
        FileDialog file = new FileDialog(view.getViewFrame(), msg, state);
        file.setFile("*.jpg;*.png;*.gif");
        // set initial filename filter
        file.show();
        // Blocks
        String curFile;
        String filename = null;
        if ((curFile = file.getFile()) != null) {
            filename = file.getDirectory() + curFile;
            imgEscolhida = new File(filename);
            txtImgFundo.setText(curFile);
        }
    }
	

    /**
     *  Description of the Method
     */
    void SalvaArquivo() {
        System.out.println("Salvando arquivo");
        try {
            File imgSalva = new File(view.getPath() + imgEscolhida.getName());
            //if(!imgSalva.exists()) {

            InputStream in = new FileInputStream(imgEscolhida);
            OutputStream out = new FileOutputStream(imgSalva);

            byte[] buf = new byte[1024];
            int len;
            while ((len = in.read(buf)) > 0) {
                out.write(buf, 0, len);
            }
            in.close();
            out.close();

        //}
        } catch (Exception e) {
            System.out.println("Salvando arquivo ERROI");
        }
    }

    /**
     *  Description of the Method
     */
    void SalvarArquivoNav() {
        try {

	  	//URL ur = applet.getCodeBase();
	  	fileName = view.getHtmlName();//ur.getFile();
	  	fileName = fileName.toUpperCase();
	  	if (fileName.indexOf(".HTML")>=0) {
			fileName = fileName.replaceAll(".HTML",".Navagedor.HTML");
	  	}
	  	else {
			if (fileName.indexOf(".HTM")>=0)
				fileName = fileName.replaceAll(".HTML",".Navagedor.HTML");
	  	}

		System.out.println(view.getPath() + fileName + " **** ");
		
            PrintWriter pw = new PrintWriter(new FileOutputStream(view.getPath() + fileName, false), false);
            pw.print("<HTML>");
            pw.write("\n");
            pw.print("<BODY  style=\"margin:0px;\">");
            pw.write("\n");
            pw.print("<applet code=\"HTApplet.class\" archive=\"hypertreeN.jar\" WIDTH=\"100%\" HEIGHT=\"100%\">");
            pw.write("\n");
            pw.print("<PARAM  name=\"htfile\"  value=\"" + lblArqHtz.getText() + "\">");
            pw.write("\n");
            pw.print("<PARAM  name=\"htFileShape\"  value=\"" + lblArqPoligonos.getText() + "\">");
            pw.write("\n");
            if (!txtCorFundo.getText().isEmpty()) {
                pw.print("<PARAM  name=\"htbackcolor\" value=\"" + txtCorFundo.getText() + "\">");
                pw.write("\n");
            }
            if (!txtCorLink.getText().isEmpty()) {
                pw.print("<PARAM  name=\"htlinkcolor\" value=\"" + txtCorLink.getText() + "\">");
                pw.write("\n");
            }
            if (!txtCorBusca.getText().isEmpty()) {
                pw.print("<PARAM  name=\"htsearchcolor\" value=\"" + txtCorBusca.getText() + "\">");
                pw.write("\n");
            }
            if (!txtCorHint.getText().isEmpty()) {
                pw.print("<PARAM  name=\"hthintcolor\" value=\"" + txtCorHint.getText() + "\">");
                pw.write("\n");
            }
			if (!txtCorGrafo.getText().isEmpty()) {
                pw.print("<PARAM  name=\"htgraphcolor\" value=\"" + txtCorGrafo.getText() + "\">");
                pw.write("\n");
            }
            if (!txtURL.getText().isEmpty()) {
                pw.print("<PARAM  name=\"hturladr\" value=\"" + txtURL.getText() + "\">");
                pw.write("\n");
            }
            if (!txtImgFundo.getText().isEmpty()) {
                pw.print("<PARAM  name=\"htbackimage\" value=\"" + txtImgFundo.getText() + "\">");
                pw.write("\n");
            }
            pw.print("<PARAM  name=\"htfont\" value=\"" + cmbFonts.getSelectedItem().toString() + "\">");
            pw.write("\n");
            pw.print("<PARAM  name=\"htFontSize\" value=\"" + cmbFontSize.getSelectedItem().toString() + "\">");
            pw.write("\n");

            if (chkLinks.isSelected()) {
                pw.print("<PARAM  name=\"htopenwindow\" value=\"new\">");
            } else {
                pw.print("<PARAM  name=\"htopenwindow\" value=\"self\">");
            }
            pw.write("\n");

            pw.print("</APPLET></BODY><HTML>");

            pw.close();
        } catch (Exception e) {
            System.out.println("Erro ao salvar o arquivo.\nErro :" + e.toString());
        }

    }

    /**
     *  Description of the Method
     */
    void SalvarArquivoEditor() {
        try {
            PrintWriter pw = new PrintWriter(new FileOutputStream(view.getPath() + view.getHtmlName(), false), false);
            pw.print("<HTML>");
            pw.write("\n");
            pw.print("<BODY  style=\"margin:0px;\">");
            pw.write("\n");
            pw.print("<applet code=\"HTApplet.class\" archive=\"ahypertreeE.jar\" WIDTH=\"100%\" HEIGHT=\"100%\">");
            pw.write("\n");
            pw.print("<PARAM  name=\"htfile\"  value=\"" + lblArqHtz.getText() + "\">");
            pw.write("\n");
            pw.print("<PARAM  name=\"htFileShape\"  value=\"" + lblArqPoligonos.getText() + "\">");
            pw.write("\n");
            if (!txtCorFundo.getText().isEmpty()) {
                pw.print("<PARAM  name=\"htbackcolor\" value=\"" + txtCorFundo.getText() + "\">");
                pw.write("\n");
            }
            if (!txtCorLink.getText().isEmpty()) {
                pw.print("<PARAM  name=\"htlinkcolor\" value=\"" + txtCorLink.getText() + "\">");
                pw.write("\n");
            }
            if (!txtCorBusca.getText().isEmpty()) {
                pw.print("<PARAM  name=\"htsearchcolor\" value=\"" + txtCorBusca.getText() + "\">");
                pw.write("\n");
            }
            if (!txtCorHint.getText().isEmpty()) {
                pw.print("<PARAM  name=\"hthintcolor\" value=\"" + txtCorHint.getText() + "\">");
                pw.write("\n");
            }
			if (!txtCorGrafo.getText().isEmpty()) {
                pw.print("<PARAM  name=\"htgraphcolor\" value=\"" + txtCorGrafo.getText() + "\">");
                pw.write("\n");
            }
            if (!txtURL.getText().isEmpty()) {
                pw.print("<PARAM  name=\"hturladr\" value=\"" + txtURL.getText() + "\">");
                pw.write("\n");
            }
            if (!txtImgFundo.getText().isEmpty()) {
                pw.print("<PARAM  name=\"htbackimage\" value=\"" + txtImgFundo.getText() + "\">");
                pw.write("\n");
            }
            pw.print("<PARAM  name=\"htfont\" value=\"" + cmbFonts.getSelectedItem().toString() + "\">");
            pw.write("\n");
            pw.print("<PARAM  name=\"htFontSize\" value=\"" + cmbFontSize.getSelectedItem().toString() + "\">");
            pw.write("\n");

            if (chkLinks.isSelected()) {
                pw.print("<PARAM  name=\"htopenwindow\" value=\"new\">");
            } else {
                pw.print("<PARAM  name=\"htopenwindow\" value=\"self\">");
            }
            pw.write("\n");

            pw.print("</APPLET></BODY><HTML>");

            pw.close();
        } catch (Exception e) {
            System.out.println("Erro ao salvar o arquivo.\nErro :" + e.toString());
        }

    }
    /**
     * @param  args  the command line arguments
     */
    /*
     *  public static void main(String args[]) {
     *  java.awt.EventQueue.invokeLater(new Runnable() {
     *  public void run() {
     *  HTDialogNavegador dialog = new HTDialogNavegador(new javax.swing.JFrame(), true);
     *  dialog.addWindowListener(new java.awt.event.WindowAdapter() {
     *  public void windowClosing(java.awt.event.WindowEvent e) {
     *  System.exit(0);
     *  }
     *  });
     *  dialog.setVisible(true);
     *  }
     *  });
     *  }
     */
    // Variables declaration - do not modify
    private javax.swing.JButton btnCorBusca;
    private javax.swing.JButton btnCorFundo;
    private javax.swing.JButton btnCorGrafo;
    private javax.swing.JButton btnCorHint;
    private javax.swing.JButton btnCorLink;
    private javax.swing.JButton btnFechar;
    private javax.swing.JButton btnImgFundo;
    private javax.swing.JButton btnSalvar;
    private javax.swing.JCheckBox chkLinks;
    private javax.swing.JComboBox cmbFontSize;
    private javax.swing.JComboBox cmbFonts;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JLabel lblArqHtz;
    private javax.swing.JLabel lblArqPoligonos;
    private javax.swing.JTextField txtCorBusca;
    private javax.swing.JTextField txtCorFundo;
    private javax.swing.JTextField txtCorGrafo;
    private javax.swing.JTextField txtCorHint;
    private javax.swing.JTextField txtCorLink;
    private javax.swing.JTextField txtImgFundo;
    private javax.swing.JTextField txtURL;
    // End of variables declaration
}

