
/*
 * HTDialogURLs.java 
 * Bruno
 * Created on 8 de Julho de 2008, 09:31
 */
import java.awt.Dimension;
import java.awt.Font;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JTextField;
import java.awt.*;

/**
 *
 * @author  Bruno
 */
public class HTDialogURLs extends javax.swing.JDialog {

    String URLs;
    String[] Endereco = new String[50];                 // String que armazena os enderecos lidos
    String[] NomeFantasia = new String[50];				// String que armazena os Nomes dos enderecos lidos
    int[] PossueNome = new int[50];						// Variavel que indica se o endereco possue um NomeFantasia
    JTextField txtNome[] = new JTextField[50];			// Array de JTextField para os Nomes
    JTextField txtEndereco[] = new JTextField[50];		// Array de JTextField para os Enderecos
    JLabel lblNome[] = new JLabel[50];					// Array de JLabel para os Nomes
    JLabel lblEndereco[] = new JLabel[50];				// Array de JLabel para os Enderecos
    JButton btnSalvar;									// JButton para Salvar
    JButton btnFechar = new JButton();					// JButton para Fechar o form
    JButton btnNovoLink = new JButton();				// JButton para criar novos links
    JLabel lblHint = new JLabel();                      // JLabel para usar como hint
    int NovosLinks = 0;									// Numero de novos links adicionados
    // Posicoes para os campos
    int LabelPosX = 10, LabelPosY = 25;
    int TextPosX = 70, TextPosY = 18;
    HTView view;

    /** Creates new form HTDialogURLs */
    public HTDialogURLs(Frame parent, HTView rview) {
        super(parent, true);
        URLs = rview.getURLField();
        view = rview;
        PercorreURL();
        ImprimeURLs();
        CriaCampos();
        CriaBotoes();
        AjustaForm();
    }

    // Funcao que percorre o URL recebido e separa os enderecos dos nomes
    private void PercorreURL() {
        String Linha;
        int Inicio = 0, InicioNome = 0, FimNome = 0;
        int Posicao = 0;

        // Verifica se existe o "@!" no final da string
        if (URLs == null || URLs.length() < 2 || (URLs.charAt(URLs.length() - 2) != '@' && URLs.charAt(URLs.length() - 1) != '!')) {
            URLs = URLs + "@!";
        }
        if (URLs.length() > 2) {
            // Percorre a string de URLs e monta a janela PopUp
            for (int h = 0; h < URLs.length(); h++) {
                // Quando encontrar o @, um link  gerado
                if ((h + 1) < URLs.length()) {
                    if ((URLs.charAt(h) == '@' && URLs.charAt(h + 1) == '!') || h == URLs.length() - 1) {
                        // Pega a parte da linha que contem o proximo Nome e Link
                        Linha = URLs.substring(Inicio, h + 1);
                        // Procura o inicio e o final do nome
                        for (int k = 0; k < Linha.length(); k++) {
                            //Inicio
                            if (Linha.charAt(k) == '`' && Linha.charAt(k + 1) == '(') {
                                InicioNome = k + 2;
                                PossueNome[Posicao] = 1;
                            }
                            //Fim
                            if (Linha.charAt(k) == ')' && Linha.charAt(k + 1) == '`') {
                                FimNome = k;
                            }
                        }

                        // Se existe o nome, coloca ele no NomeFantasia, se nao coloca o link no NomeFantasia
                        if (PossueNome[Posicao] == 1) {
                            NomeFantasia[Posicao] = Linha.substring(InicioNome, FimNome).trim(); //.replace(")", "").replace("!", "")
                            //URL  o comeco da string Endereco ate o comeco do InicioNome - 1
                            Endereco[Posicao] = Linha.substring(0, InicioNome - 2).replace("!", "").trim(); //.replace("!", "").replace("(", "")
                        } else {
                            // Quando nao existe nome, o final eh o tamanho do Endereco
                            Endereco[Posicao] = NomeFantasia[Posicao] = Linha.substring(0, Linha.length() - 1).replace("!", "").trim(); //
                        }

                        // Posicao na string de URL que deve comecar o proximo endereco
                        Inicio = h + 1;
                        Posicao++;
                    }
                }
            }
        }
    }

    /* Conta quantos links tem na string */
    int ContaLinks() {
        int NumLinks = 0;
        if (URLs != null) {
            for (int i = 0; i < URLs.length(); i++) {
                if (URLs.charAt(i) == '@' && URLs.charAt(i + 1) == '!') {
                    NumLinks++;
                }
            }
            return NumLinks;
        } else {
            System.out.println("Nao possue URL");
            return 0;
        }
    }

    /* Imprime os URLs e Nomes encontrados */
    void ImprimeURLs() {
        for (int h = 0; h < ContaLinks(); h++) {
            System.out.println("Nome fantasia : " + NomeFantasia[h] + " Endereco : " + Endereco[h]);
        }
    }

    // Funcao que cria os campos no form
    void CriaCampos() {

        // Fonte dos labels
        Font f = new Font("tahoma", Font.BOLD, 11);

        // Loop que gera os campos 
        for (int h = 0; h < ContaLinks(); h++) {
            try {
                // Cria o Label Nome
                lblNome[h] = new JLabel(); //370
                lblNome[h].setBounds(LabelPosX + 470, (LabelPosY + (h * 20)), 80, 10);
                lblNome[h].setText("Nome : ");
                lblNome[h].setFont(f);

                // Cria o JtextField para o NomeFantasia
                txtNome[h] = new JTextField();
                txtNome[h].setText(NomeFantasia[h]); //350
                txtNome[h].setBounds(TextPosX + 450, (TextPosY + (h * 20)), 300, 20);

                // Cria o Label Nome
                lblEndereco[h] = new JLabel();
                lblEndereco[h].setBounds(LabelPosX, (LabelPosY + (h * 20)), 80, 12);
                lblEndereco[h].setText("Endereo : ");
                lblEndereco[h].setFont(f);

                // Cria o JtextField para o Endereco
                txtEndereco[h] = new JTextField();
                txtEndereco[h].setText(Endereco[h]);
                txtEndereco[h].setBounds(TextPosX, (TextPosY + (h * 20)), 400, 20);

            } catch (Exception e) {
                System.out.println("Erro : " + e);
            }
        }
    }

    // Funcao que cria os botoes no form
    void CriaBotoes() {
        try {
            // Cria o botao Salvar
            btnSalvar = new JButton();
            btnSalvar.setText("Salvar");

            btnSalvar.addActionListener(new java.awt.event.ActionListener() {

                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    SalvarLinks();
                }
            });


            // Cria o botao Fechar
            btnFechar = new JButton();
            btnFechar.setText("Fechar");

            btnFechar.addActionListener(new java.awt.event.ActionListener() {

                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    FecharForm();
                }
            });

            // Cria o botao NovoLink
            btnNovoLink = new JButton();
            btnNovoLink.setText("Novo Link");
            // btnNovoLink.setBounds(((734 / 2) + 110), (((NovosLinks + ContaLinks()) * 20) + 30), 200, 20);

            btnNovoLink.addActionListener(new java.awt.event.ActionListener() {

                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    NovoLink();
                }
            });
        } catch (Exception e) {
            System.out.println("Erro : " + e);
        }
    }
    // Funcao que salva os links dos textbox
    void SalvarLinks() {
        int pos = 0;
        String NovoURL = "";
        try {
            for (int h = 0; h < (ContaLinks() + NovosLinks); h++) {
                if (txtEndereco[h].getText().length() > 0) {
                    if (pos == 0) {
                        NovoURL = NovoURL + txtEndereco[h].getText();
                        pos++;
                    } else {
                        NovoURL = NovoURL + txtEndereco[h].getText();
                    }
                    if (txtNome[h].getText().length() > 0) {
                        NovoURL = NovoURL + "`(" + txtNome[h].getText() + ")`";
                    } else {
                        NovoURL = NovoURL + "`(" + txtEndereco[h].getText() + ")`";
                    }
                    NovoURL = NovoURL + "@!";
                }
            }
		System.out.println(NovoURL);
            view.setURLField(new TextField(NovoURL));

        } catch (Exception e) {
            System.out.println("[SalvarLinks] Erro : " + e);
        }
    }

    // Funcao para fechar o form
    void FecharForm() {
        this.dispose();
    }
    // Funcao que insere novos campos para os links
    void NovoLink() {
        NovosLinks++;
        int h = ContaLinks() + NovosLinks - 1;
        System.out.println("H : " + h);
        // Fonte dos labels
        Font f = new Font("tahoma", Font.BOLD, 11);

        try {
            // Cria o Label Nome
            lblNome[h] = new JLabel();
            lblNome[h].setBounds(LabelPosX + 470, (LabelPosY + (h * 20)), 80, 10);
            lblNome[h].setText("Nome : ");
            lblNome[h].setFont(f);

            // Cria o JtextField para o NomeFantasia
            txtNome[h] = new JTextField();
            txtNome[h].setBounds(TextPosX + 450, (TextPosY + (h * 20)), 300, 20);

            // Cria o Label Nome
            lblEndereco[h] = new JLabel();
            lblEndereco[h].setBounds(LabelPosX, (LabelPosY + (h * 20)), 80, 12);
            lblEndereco[h].setText("Endereo : ");
            lblEndereco[h].setFont(f);

            // Cria o JtextField para o Endereco
            txtEndereco[h] = new JTextField();
            txtEndereco[h].setBounds(TextPosX, (TextPosY + (h * 20)), 400, 20);

        } catch (Exception e) {
            System.out.println("Erro : " + e);
        }

        // Chama a funcao para redesenhar o form
        AjustaForm();
    }
    // Funcao que ajusta o form dependendo da quantidade de campos
    void AjustaForm() {
        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        this.setTitle("Endereos para o n");
        // Tamanho do form
        int largura = 834;
        int altura = (NovosLinks + ContaLinks()) * 20 + 120;
        this.setMinimumSize(new Dimension(largura, altura));
        // Nao deixa o usuario mexer no tamanho
        this.setResizable(false);

        // Coloca os componentes no form
        for (int h = 0; h < (ContaLinks() + NovosLinks); h++) {
            this.add(lblNome[h]);
            this.add(lblEndereco[h]);
            this.add(txtNome[h]);
            this.add(txtEndereco[h]);
        }

        // Cria o label de hint
        lblHint.setText("Para remover o link, apague o endereo.");
        lblHint.setBounds(((largura / 2) - 310), (((NovosLinks + ContaLinks()) * 20) + 30), 700, 20);
        this.add(lblHint);
        // Ajusta a posicao dos botoes
        btnNovoLink.setBounds(((largura / 2) + 110), (((NovosLinks + ContaLinks()) * 20) + 60), 200, 20);
        btnSalvar.setBounds(((largura / 2) - 310), (((NovosLinks + ContaLinks()) * 20) + 60), 200, 20);
        btnFechar.setBounds((largura / 2) - 100, (((NovosLinks + ContaLinks()) * 20) + 60), 200, 20);
        this.add(btnSalvar);
        this.add(btnNovoLink);
        this.add(btnFechar);

        pack();
    }
}
